/*
 *
 *  Created on: Mar 1, 2021
 *      Author: astrisw
 */

#ifndef FILEARCHIVER_H_
#define FILEARCHIVER_H_

#include <fstream>
#include <Base_Archiver.h>
#include <Base_Configurator.h>

namespace inaf::oasbo::Archivers {

class FileArchiver: public BaseArchiver {
protected:
	std::ofstream *myfile = nullptr;
	std::string computeFileName(std::string fileName);
	FileArchiver(std::string dest);
	FileArchiver(std::string parent, std::string dest);
	FileArchiver();
public:
	std::string parentPath;

	int write(PacketLib::BasePacket&) override;
	int write(PacketLib::BasePacket&, std::string dest) override;

	int close() override;
	int open() override;
	void setDest(std::string) override;
	void updateDest() override;
	std::string getDest() override;
	~FileArchiver() {
		close();
	}

	friend class Builder;
	class Builder {
	protected:
		FileArchiver *arch;
	public:
		std::string file_name_key { "file_name" };
		std::string archive_path_key { "archive_path" };

		Builder();
		Builder(std::string dest);
		Builder(std::string parent, std::string dest);
		~Builder();

		void reset();

		Builder* configFrom(Configurators::BaseConfigurator *conf);

		Builder* setParent(std::string parent);

		Builder* setDest(std::string dest);

		FileArchiver* getArchiver();
	};

};
}
#endif /* FILEARCHIVER_H_ */
